using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.IO;

using Syncfusion.Windows.Forms.Tools;


namespace dockwindow_position
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private Syncfusion.Windows.Forms.Tools.DockingManager dockingManager1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.Panel panel3;

		private List<System.Windows.Forms.Panel> lstPnls = new List<Panel>();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            //Syncfusion.Windows.Forms.Tools.XPMenus.BarItem oMenu = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
            //oMenu.Text = "test";
            mainMenu1.MenuItems.Add("NewDockPnls", XXHandler);
			mainMenu1.MenuItems.Add("NewTabPnls", XXHandlerTab);
            System.Windows.Forms.MenuItem oLayout = new System.Windows.Forms.MenuItem();
            System.Windows.Forms.MenuItem oLayout1 = new System.Windows.Forms.MenuItem();
            System.Windows.Forms.MenuItem oLayout2 = new System.Windows.Forms.MenuItem();
			System.Windows.Forms.MenuItem oLayout3 = new System.Windows.Forms.MenuItem();

            oLayout.Text = "Layout";
            oLayout1.Text = "Save";
            oLayout1.Click += new EventHandler(LayoutSave_Click);
            oLayout2.Text = "Load";
            oLayout2.Click += new EventHandler(LayoutLoad_Click);
			oLayout3.Text = "Load2";
			oLayout3.Click += new EventHandler(LayoutLoad2_Click);
            oLayout.MenuItems.Add(oLayout1);
            oLayout.MenuItems.Add(oLayout2);
			oLayout.MenuItems.Add(oLayout3);
            System.Windows.Forms.MenuItem x = mainMenu1.MenuItems["Layout"];
            mainMenu1.MenuItems.Add(oLayout);            

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

        void LayoutLoad_Click(object sender, EventArgs e)
        {
			ControlConfigCollection oC = new ControlConfigCollection();
			oC.Load();

			//remove all controls so that only controls given in configuration loaded will be present.
			dockingManager1.SetEnableDocking(panel1, false);
			dockingManager1.SetEnableDocking(panel2, false);
			dockingManager1.SetEnableDocking(panel3, false);
			for (int i = 0; i < lstPnls.Count; ++i)
			{
				dockingManager1.SetEnableDocking(lstPnls[i], false);
			}

			//hide all
			panel1.Visible = false;
			panel2.Visible = false;
			panel3.Visible = false;
			for (int i = 0; i < lstPnls.Count; ++i)
			{
				lstPnls[i].Visible = false;
			}
			
			//create / configure / dock one by one.
			for (int i = 0; i < oC.m_lstConfigs.Count; ++i)
			{
				ControlConfiguration oConfig = oC.m_lstConfigs[i];
				System.Windows.Forms.Panel pnl = null;
				if ("panel1" == oConfig.Name)
					pnl = panel1;		//static control
				else if ("panel2" == oConfig.Name)
					pnl = panel2;		//static control
				else if ("panel3" == oConfig.Name)
					pnl = panel3;		//static control
				else
				{
					//dynamic control
					foreach (Control c in lstPnls)
					{
						if(c.Name == oConfig.Name)
						{
							//existing one
							pnl = (Panel)c;
							break;
						}
					}
					//not found, create with given name
					if (null == pnl)
						pnl = GetPanel(oConfig.Name);
				}
				
				Control oParent = null;		//control to which the new control has to be docked
				if (oConfig.RelatedControl.Length == 0)
					oParent = this;			//length 0 --> dock to form
				else
					oParent = GetParent(oConfig);	////dock to a known control
								
//				//dockingManager1.SetEnableDocking(pnl, true);
				dockingManager1.SetDockLabel(pnl, pnl.Name);
				dockingManager1.DockControl(pnl, oParent, (Syncfusion.Windows.Forms.Tools.DockingStyle)oConfig.DockStyle, oConfig.Width);
				dockingManager1.SetControlSize(pnl, new Size(oConfig.Width, oConfig.Height));
				//set visibility for non tabbed controls
				if (-1 == oConfig.TabGroup)
					dockingManager1.SetDockVisibility(pnl, oConfig.Visibility);
				
			}			
        }

		void LayoutLoad2_Click(object sender, EventArgs e)
		{
			ControlConfigCollection oC = new ControlConfigCollection();
			oC.Load();

			//remove all controls so that only controls given in configuration loaded will be present.
			dockingManager1.SetEnableDocking(panel1, false);
			dockingManager1.SetEnableDocking(panel2, false);
			dockingManager1.SetEnableDocking(panel3, false);
			for (int i = 0; i < lstPnls.Count; ++i)
			{
				dockingManager1.SetEnableDocking(lstPnls[i], false);
			}

			//hide all
			panel1.Visible = false;
			panel2.Visible = false;
			panel3.Visible = false;
			for (int i = 0; i < lstPnls.Count; ++i)
			{
				lstPnls[i].Visible = false;
			}

			//create / configure / dock one by one.
			for (int i = 0; i < oC.m_lstConfigs.Count; ++i)
			{
				ControlConfiguration oConfig = oC.m_lstConfigs[i];
				System.Windows.Forms.Panel pnl = null;
				if ("panel1" == oConfig.Name)
					pnl = panel1;		//static control
				else if ("panel2" == oConfig.Name)
					pnl = panel2;		//static control
				else if ("panel3" == oConfig.Name)
					pnl = panel3;		//static control
				else
				{
					//dynamic control
					foreach (Control c in lstPnls)
					{
						if (c.Name == oConfig.Name)
						{
							//existing one
							pnl = (Panel)c;
							break;
						}
					}
					//not found, create with given name
					if (null == pnl)
						pnl = GetPanel(oConfig.Name);
				}

				Control oParent = null;		//control to which the new control has to be docked
				if (oConfig.RelatedControl.Length == 0)
					oParent = this;			//length 0 --> dock to form
				else
					oParent = GetParent(oConfig);	////dock to a known control

				//dockingManager1.SetEnableDocking(pnl, true);
				dockingManager1.SetDockLabel(pnl, pnl.Name);
				dockingManager1.DockControl(pnl, oParent, (Syncfusion.Windows.Forms.Tools.DockingStyle)oConfig.DockStyle, oConfig.Width);
				dockingManager1.SetControlSize(pnl, new Size(oConfig.Width, oConfig.Height));
				//set visibility for non tabbed controls
				if (-1 == oConfig.TabGroup)
					dockingManager1.SetDockVisibility(pnl, oConfig.Visibility);

				DockHost dh = pnl.Parent as DockHost;
				DockHostController dhc = dh.InternalController as DockHostController;

				DockInfo di = new DockInfo(dhc.DINew);
				di.DP = (DockPreference)oConfig.DockPreference;
				di.dStyle = (DockingStyle)oConfig.DockStyle;
				di.rcDockArea.Location = new Point(oConfig.Left, oConfig.Top);
				di.rcDockArea.Size = new Size(oConfig.Width, oConfig.Height);

				dhc.DINew = di;
				dhc.ApplyDockInfo();
				di.dController.AdjustLayout();
			}
		}

        void LayoutSave_Click(object sender, EventArgs e)
        {
            //throw new NotImplementedException();

			ControlConfigCollection oC = new ControlConfigCollection();

			//get all controls and their properties
			Hashtable hashControls = new Hashtable();

			int nTabGrp = 0;
			int nIdx = 0;
			foreach (Control oControl in dockingManager1.ControlsArray)
			{
				ControlConfiguration oControlConfig = new ControlConfiguration();

				oControlConfig.Visibility = oControl.Visible;
				oControlConfig.Enabled = oControl.Enabled;
				oControlConfig.Name = oControl.Name;
				oControlConfig.RelatedControl = "";  //name of control to which this control has to be docked
				oControlConfig.Left = oControl.Location.X;
				oControlConfig.Top = oControl.Location.Y;
				oControlConfig.Width = oControl.Size.Width;
				oControlConfig.Height = oControl.Size.Height;
				oControlConfig.TabIndex = 0;
				oControlConfig.TabGroup = -1;
				oControlConfig.ControlIdx = nIdx++;
				oControlConfig.DockStyle = (int)Syncfusion.Windows.Forms.Tools.DockingStyle.Bottom;
				oControlConfig.DockPreference = (int)Syncfusion.Windows.Forms.Tools.DockPreference.All;

				DockHost dh = oControl.Parent as DockHost;
				DockHostController dhc = dh.InternalController as DockHostController;

				if (dockingManager1.IsTabbed(oControl))
				{
					//this control is tabbed control
					if (!hashControls.Contains(oControl.Name))
					{
						//this tab group is observed for first time
						hashControls[oControl.Name] = nTabGrp++;
					}
					oControlConfig.TabGroup = (int)hashControls[oControl.Name];
					
					//DockHost dh = oControl.Parent as DockHost;
					//DockHostController dhc = dh.InternalController as DockHostController;
					
					oControlConfig.TabIndex = dockingManager1.GetTabPosition(oControl);
					oControlConfig.DockStyle = (int)Syncfusion.Windows.Forms.Tools.DockingStyle.Tabbed;
					oControlConfig.DockPreference = (int)Syncfusion.Windows.Forms.Tools.DockPreference.Tabbed;

					//int nHC = oControl.Size.Height;					
					Control[] arrSiblings = dockingManager1.GetTabbedSiblings(oControl);
					foreach (Control x in arrSiblings)
					{
						int nPs = dockingManager1.GetTabPosition(x);

						if (x.Name == oControl.Name)
						{
							if (0 == nPs)
							{
								//the first item in tab group, change the dock style as normal
								//oControlConfig.DockStyle = (int)Syncfusion.Windows.Forms.Tools.DockingStyle.Bottom;
								oControlConfig.DockStyle = (int)dhc.DINew.dStyle;
							}
							continue; //self 
						}						
						if (0 == nPs)
						{
							//dock the control to this item which is the first item in tab group
							oControlConfig.RelatedControl = x.Name;
						}

						if (!hashControls.Contains(x.Name))
						{
							hashControls[x.Name] = hashControls[oControl.Name];
						}
						
					}
				}
				else if (dockingManager1.IsFloating(oControl))
				{
					//floating one
					hashControls[oControl.Name] = -1; //no tab grp

					//MessageBox.Show(oControl.Name + " " + "floating");
				}
				else
				{
					//docked one
					hashControls[oControl.Name] = -1; //no tab grp

					//DockHost dh = oControl.Parent as DockHost;
					//DockHostController dhc = dh.InternalController as DockHostController;
					if (dhc.ParentController is SizingController)
					{
						//MessageBox.Show(oControl.Name + " " + "Docked");

						DockInfo dkinf = dhc.DICurrent;
												
						oControlConfig.DockStyle = (int)dockingManager1.GetDockStyle(oControl);
						oControlConfig.DockPreference = (int)Syncfusion.Windows.Forms.Tools.DockPreference.None;
						if (oControlConfig.DockStyle != (int)dhc.DICurrent.dStyle)
						{
							oControlConfig.DockStyle = (int)dhc.DICurrent.dStyle;
						}

						/*//docked
						oControlConfig.Parent = "";
						oControlConfig.Left = dhc.DICurrent.rcDockArea.Left; oControlConfig.Top = dhc.DICurrent.rcDockArea.Top;
						oControlConfig.Width = dhc.DICurrent.rcDockArea.Width; oControlConfig.Height = dhc.DICurrent.rcDockArea.Height;
						oControlConfig.DockStyle = (int)dhc.DICurrent.dStyle;
						oControlConfig.DockPreference = (int)dhc.DICurrent.DP;

						Point pt = oControl.Location;
						pt = PointToScreen(pt);

						//hashControls.Add(oControl.AccessibleName, oControl);
						//lstControls.Add(oControlConfig);*/
					}
					else
					{
						//invalid? - improbable - hidden?
						//MessageBox.Show(oControl.Name + " " + "Hidden?");						
					}
				}

				/*oControlConfig.Top = dhc.DINew.rcDockArea.Location.Y;
				oControlConfig.Left = dhc.DINew.rcDockArea.Location.X;
				oControlConfig.Width = dhc.DINew.rcDockArea.Size.Width;
				oControlConfig.Height = dhc.DINew.rcDockArea.Size.Height;
				oControlConfig.DockPreference = (int)dhc.DINew.DP;
				if(DockingStyle.Tabbed != dhc.DINew.dStyle)
					oControlConfig.DockStyle = (int)dhc.DINew.dStyle;
				else
					oControlConfig.DockStyle = oControlConfig.DockStyle;*/

				oControlConfig.Top = dhc.DICurrent.rcDockArea.Location.Y;
				oControlConfig.Left = dhc.DICurrent.rcDockArea.Location.X;
				oControlConfig.Width = dhc.DICurrent.rcDockArea.Size.Width;
				oControlConfig.Height = dhc.DICurrent.rcDockArea.Size.Height;
				oControlConfig.DockPreference = (int)dhc.DICurrent.DP;

				oC.Add(oControlConfig);
			}

			//sort by dock type, tab group and then by position of tabs
			oC.m_lstConfigs.Sort(new SortByX1());
			oC.Save();			
        }

		//get control the control for the given configuration
		private Control GetParent(ControlConfiguration oConfig)
		{			
			if (oConfig.RelatedControl == "panel1")
				return panel1;
			else if (oConfig.RelatedControl == "panel2")
				return panel2;
			else if (oConfig.RelatedControl == "panel3")
				return panel3;
			else
			{
				//docking to a dynamic panel, get it
				foreach (Control pnl in lstPnls)
				{
					if (pnl.Name == oConfig.RelatedControl)
						return pnl;
				}

				//not found, have to create the panel to which this one will be docked
				Panel oNewPnl = GetPanel();
				lstPnls.Add(oNewPnl);
				return oNewPnl;
			}
		}

		//get a new panel
		private System.Windows.Forms.Panel GetPanel()
		{
			System.Windows.Forms.Panel pnl = new Panel();

			int nPs = 4 + lstPnls.Count;
			//this.dockingManager1.SetEnableDocking(pnl, true);
			pnl.Location = new System.Drawing.Point(1, 21);
			pnl.Name = "panel" + nPs.ToString();
			pnl.Size = new System.Drawing.Size(130, 264);
			pnl.TabIndex = nPs;
			lstPnls.Add(pnl);

			return pnl;
		}

		//get a new panel with a given name
		private System.Windows.Forms.Panel GetPanel(string strName)
		{
			if (strName == "panel1")
				return panel1;
			else if (strName == "panel2")
				return panel2;
			else if (strName == "panel3")
				return panel3;
			else
			{
				foreach (Panel pnl in lstPnls)
				{
					if (pnl.Name == strName)
						return pnl;
				}
			}
			System.Windows.Forms.Panel Newpnl = new Panel();
			int nPs = 4 + lstPnls.Count;
			//this.dockingManager1.SetEnableDocking(pnl, true);
			Newpnl.Name = strName;
			Newpnl.TabIndex = nPs;
			lstPnls.Add(Newpnl);

			return Newpnl;
		}

		//add docked panel
		private void XXHandler(object sender, EventArgs e)
		{
			System.Windows.Forms.Panel pnl = GetPanel();
			
			dockingManager1.DockControl(pnl, this, Syncfusion.Windows.Forms.Tools.DockingStyle.Bottom, 200);			
			dockingManager1.SetDockLabel(pnl, pnl.Name);
		}  

		//add tabbed panel to first visible dynamic panel
        private void XXHandlerTab(object sender, EventArgs e)
        {
			Control oC = null;

			//get visible dynamic panel
			for (int i = 0; i < lstPnls.Count; ++i)
			{
				if (true == lstPnls[i].Visible)
				{
					oC = lstPnls[i];
					break;
				}
			}
			if (null == oC)
				return;

			//get new panel
			System.Windows.Forms.Panel pnl = GetPanel();

			//add new panel as tabbed one to visible panel
			dockingManager1.DockControl(pnl, oC, Syncfusion.Windows.Forms.Tools.DockingStyle.Tabbed, 0, false);
			dockingManager1.SetDockLabel(pnl, pnl.Name);
			
			lstPnls.Add(pnl);
        }        

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.dockingManager1 = new Syncfusion.Windows.Forms.Tools.DockingManager(this.components);
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).BeginInit();
			// 
			// panel1
			// 
			this.dockingManager1.SetEnableDocking(this.panel1, true);
			this.panel1.Location = new System.Drawing.Point(1, 21);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(130, 264);
			this.panel1.TabIndex = 0;
			// 
			// panel2
			// 
			this.dockingManager1.SetEnableDocking(this.panel2, true);
			this.panel2.Location = new System.Drawing.Point(1, 21);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(150, 264);
			this.panel2.TabIndex = 1;
			// 
			// dockingManager1
			// 
			this.dockingManager1.DockLayoutStream = ((System.IO.MemoryStream)(resources.GetObject("dockingManager1.DockLayoutStream")));
			this.dockingManager1.HostControl = this;
			this.dockingManager1.NewDockStateEndLoad += new System.EventHandler(this.dockingManager1_NewDockStateEndLoad);
			this.dockingManager1.SetDockLabel(this.panel1, "panel1");
			this.dockingManager1.SetDockLabel(this.panel2, "panel2");
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem3,
																					  this.menuItem4});
			this.menuItem1.Text = "Position Info";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "Panel1";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "Panel2";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "Panel3";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 286);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.dockingManager1)).EndInit();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			this.GetPositionInfo(this.panel1);
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			this.GetPositionInfo(this.panel2);		
		}

		private void GetPositionInfo (Panel panel)
		{	
			int left, right, top, bottom;

			Syncfusion.Windows.Forms.Tools.DockHost dhost = panel.Parent as Syncfusion.Windows.Forms.Tools.DockHost; 
			Syncfusion.Windows.Forms.Tools.DockHostController dhc = dhost.InternalController as Syncfusion.Windows.Forms.Tools.DockHostController; 
			Syncfusion.Windows.Forms.Tools.DockInfo di = dhc.DICurrent;
			
			left = di.rcDockArea.Left;
			top = di.rcDockArea.Top;
			bottom = di.rcDockArea.Bottom;
			right = di.rcDockArea.Right;

			string dockStyle = di.dStyle.ToString();

			MessageBox.Show("DockingStyle : " + dockStyle + "\n" + "Bounds : " + di.rcDockArea.ToString());
		}

		private void dockingManager1_NewDockStateEndLoad(object sender, System.EventArgs e)
		{
            //return;
			panel3 = new Panel();
			panel3.Name = "panel3";
			//dockingManager1.DockControl(panel3, this, Syncfusion.Windows.Forms.Tools.DockingStyle.Bottom, 200);
            dockingManager1.DockControl(panel3, panel2, Syncfusion.Windows.Forms.Tools.DockingStyle.Tabbed, 0, true);
			dockingManager1.SetDockLabel(panel3, "panel3");
		}

		private void menuItem4_Click(object sender, System.EventArgs e)
		{
			this.GetPositionInfo(this.panel3);
		}
	}

	public class ControlConfiguration
	{
		public bool Visibility { get; set; }
		public bool Enabled { get; set; }
		public string Name { get; set; }
		public string RelatedControl { get; set; }
		public int Left { get; set; }
		public int Top { get; set; }
		public int Width { get; set; }
		public int Height { get; set; }
		public int TabGroup { get; set; }
		public int TabIndex { get; set; }
		public int DockStyle { get; set; }
		public int DockPreference { get; set; }
		public int ControlIdx {get;set;}
		
		public int Size { get; set; }

		public ControlConfiguration()
		{
		}
	}

	public class SortByTabGrp : IComparer<ControlConfiguration>
	{
		public int Compare(ControlConfiguration a, ControlConfiguration b)
		{
			if (a.TabGroup == b.TabGroup)
				return a.TabIndex.CompareTo(b.TabIndex);
			else
				return a.TabGroup.CompareTo(b.TabGroup);
		}
	}

	public class SortByIdx : IComparer<ControlConfiguration>
	{
		public int Compare(ControlConfiguration a, ControlConfiguration b)
		{
			return a.ControlIdx.CompareTo(b.ControlIdx);
			
		}
	}

	public class SortByX : IComparer<ControlConfiguration>
	{
		public int Compare(ControlConfiguration a, ControlConfiguration b)
		{
			if (0 == a.DockStyle.CompareTo(b.DockStyle))
			{
				return a.ControlIdx.CompareTo(b.ControlIdx);
			}
			else
			{
				return a.DockStyle.CompareTo(b.DockStyle);
			}

		}
	}

	public class SortByX1 : IComparer<ControlConfiguration>
	{
		public int Compare(ControlConfiguration a, ControlConfiguration b)
		{
			if (0 == a.DockStyle.CompareTo(b.DockStyle))
			{
				if (0 == a.TabGroup.CompareTo(b.TabGroup))
				{
					return a.TabIndex.CompareTo(b.TabIndex);
				}
				return a.TabGroup.CompareTo(b.TabGroup);
			}
			else
			{
				return a.DockStyle.CompareTo(b.DockStyle);
			}
		}
	}

	public class ControlConfigCollection
	{
		public List<ControlConfiguration> m_lstConfigs = new List<ControlConfiguration>();
		public ControlConfigCollection()
		{
		}

		public void Add(ControlConfiguration oConfig)
		{
			m_lstConfigs.Add(oConfig);
		}

		public void Save()
		{
			XmlSerializer oSerializer = new XmlSerializer(typeof(ControlConfigCollection));
			StringWriter textWriter = new StringWriter();			
			StreamWriter oSW = new StreamWriter("e:\\debug\\result.xml", false, System.Text.Encoding.Unicode);

			oSerializer.Serialize(textWriter, this);

			oSW.Write(textWriter.ToString());
			oSW.Close();
		}

		public void Load()
		{
			XmlSerializer oSerializer = new XmlSerializer(typeof(ControlConfigCollection));
			StreamReader oSR = new StreamReader("e:\\debug\\result.xml", true);

			ControlConfigCollection oColl = (ControlConfigCollection) oSerializer.Deserialize(oSR);
			oSR.Close();

			m_lstConfigs = oColl.m_lstConfigs;
		}
	}
}
